Include "particle.bb"
Include "file.bb"
Include "land.bb"
Include "Gun.bb"
Include "Command.bb"

Global SonExplShip
Global SonRebondShip

Type TypeShip
	Field name$
	;dplacement
	Field x#,y#,accel#
	Field pousee#,poid#,perte#
	Field vitesseX#,vitesseY#
	;infos
	Field VieMax%
	Field Vie#
	Field Vivent%
	Field bouclier#
	Field score%
	;rotation
	Field angle#,vitesseRot#
	Field accelRot#,perteRot#,pouseeRot#
    
	Field image	;36 images
	Field imagePower
	Field dureeParticle#
	
	Field rayonShip%
	Field TailleImg%
	Field nbImage%
	Field pasRot% 
	
	Field sonFire 
	Field chnlFire
	Field chnlGun
	
	Field IA.typeIa
	
	Field Gun.TypeGun
	
	Field Command.TypeCommand
End Type 
;----------------------------------------------------------------------
;constructeur de l'objt Ship (vesseau)
;----------------------------------------------------------------------
Function CreateShip.TypeShip(path$)

	Local Ship.TypeShip
	ship= New TypeShip
	
	fich=ReadFile(path+"data.shp")
	
	;;;constentes
	file_find(fich,"[name]")
	ship\name = ReadLine(fich)
	file_find(fich,"[carac]")
	ship\pousee=file_ReadFloat(fich)
	ship\perte=file_ReadFloat(fich)
	ship\poid=file_ReadFloat(fich)
	
	
	ship\pouseeRot=file_ReadFloat(fich)
	ship\perteRot=file_ReadFloat(fich)
	
	;;;variables
	ship\Bouclier=file_ReadFloat(fich)
	ship\dureeParticle=file_ReadFloat(fich)
	ship\TailleImg=file_ReadFloat(fich)
	ship\rayonShip=file_ReadFloat(fich)
	ship\nbImage=file_ReadFloat(fich)
	ship\pasRot=360/ship\nbImage
	ship\vieMax=100
	ship\Score=0

	CloseFile(fich)
	
	;;;Image
	;image ship
	ship\image=LoadAnimImage(path+"sprite.png",ship\tailleImg,ship\tailleImg,0,ship\nbImage)
	MidHandle ship\image
	MaskImage (ship\image,255,0,0)
		
	;image power
	ship\imagePower=LoadAnimImage(path+"power.png",15,15,0,10)
	MidHandle ship\imagePower
	MaskImage (ship\imagePower,255,0,0)
	
	ship\sonFire = LoadSound(path+"fire.wav")
	LoopSound(ship\sonFire)
	Return Ship
End Function
;----------------------------------------------------------------------
; calcule l'tat suivant du vesseau 
;----------------------------------------------------------------------
Function ship_NextState(Ship.TypeShip)
	If ship\vivent Then 
		;;;test des actions
	
			
	  If ship\ia=Null Then 
		;gun
		If KeyDown(ship\Command\Fire) Then 
			gun_shoot(ship) 
		Else 
			StopChannel(ship\chnlGun)
		EndIf 
	
		;pouse
		If KeyDown(ship\Command\bas)Then 
			Ship_pouseOn(ship)
		Else 
			Ship_pouseOff(ship)
		EndIf
	
		;angle
		ship\accelRot=0
		If KeyDown(ship\Command\droite) Then ship\accelRot=-ship\pouseeRot
		If KeyDown(ship\Command\gauche) Then ship\accelRot=ship\pouseeRot
	  Else
		ia_nextState(ship\Ia)
	  EndIf

		;;;physique
		;rotation
		ship\vitesseRot=(ship\vitesseRot+ship\accelRot)*(1-ship\perteRot)
		ship_Tourne(Ship,-ship\vitesseRot)
	
		;affichage de la fume si la vie est basse
		If ship\Vie<ship\VieMax/2 And (Not Rand(0,ship\vie/4)) Then particlesFume=CreateParticleFume(ship) 
	
	
		;position
		;cacul de la vitesse du vsseau
		ship\vitesseY=(ship\vitesseY +( Sin(ship\angle) * ship\accel))*(1-ship\perte) + (ship\poid * gravite)
		ship\vitesseX=(ship\vitesseX +( Cos(ship\angle) * ship\accel))*(1-ship\perte)
		;Dplacement en fnct de la vitesse
		ship\y=ship\y + ship\vitesseY  
		ship\x=ship\x + ship\vitesseX  
	
	Else 
		StopChannel(ship\chnlFire)
		StopChannel(ship\chnlGun)
		If ship\ia=Null Then 
			If KeyHit(ship\Command\Fire) Then ship_reinit(Ship)
		Else 
			ship_reinit(Ship)
		EndIf
	EndIf
	
End Function
;----------------------------------------------------------------------
; Teste si il y a une collision avec land 
;----------------------------------------------------------------------
Function ship_TestColision(Ship.TypeShip,land.typeLand)
	If ship\vivent Then
		If Ship\gun\TypeG=Invincible Then
			diminuGun(ship)
			If (ship\x-ship\tailleImg/2<=0) Or (ship\x+ship\tailleImg/2>=land\larg) Then ship\x=ship\x-ship\vitesseX ship\vitesseX=-ship\vitesseX 
			If (ship\Y-ship\tailleImg/2<=0) Or (ship\Y+ship\tailleImg/2>=land\Haut) Then ship\y=ship\y-ship\vitesseY ship\vitesseY=-ship\vitesseY
		Else 
			If land_isThereaColision(Ship.TypeShip,ship\x,ship\y)
				ship\x=ship\x-ship\vitesseX
				ship\y=ship\y-ship\vitesseY
				ship\vitesseX=-ship\vitesseX
				ship\vitesseY=-ship\vitesseY
				ship\vitesseRot=-ship\vitesseRot
				ship_degat(ship,Null,1)	
				PlaySound(SonRebondShip)
			Else 
				If Not isPTin(ship\x,ship\y,0,0,land\larg,land\haut) Then ship_degat(ship,Null,1)	
			EndIf
		EndIf
	EndIf
End Function
;----------------------------------------------------------------------
Function ship_TestColision2(Ship.TypeShip,land.typeLand)
	If ship\vivent Then
		If land_isThereaColision(Ship.TypeShip,ship\x,ship\y)
			Local coef#=ship\PouseeRot*8;/ship\perteRot*2
			
			PlaySound(SonRebondShip)
			Local rebondH = Not land_isThereaColision(Ship.TypeShip,ship\x-ship\vitesseX,ship\y) 
			Local rebondV = Not land_isThereaColision(Ship.TypeShip,ship\x,ship\y-ship\vitesseY)
			If (Not rebondH) And (Not rebondV) Then 
				rebondV=True 
				rebondH=True
			EndIf
			If rebondH Then 	
				If ship\vitesseX>0 Then 
					ship\X=ship\X-1
					ship\vitesseX=ship\vitesseX+Abs(ship\vitesseRot)/coef
				;	ship\vitesseY=ship\vitesseY-ship\vitesseRot/coef
				Else 
					ship\X=ship\X+1
					ship\vitesseX=ship\vitesseX-Abs(ship\vitesseRot)/coef
				;	ship\vitesseY=ship\vitesseY+ship\vitesseRot/coef
				EndIf
				ship\X=ship\X-ship\vitesseX
				ship\vitesseX=-ship\vitesseX
			EndIf
			If  rebondV Then 
				If ship\vitesseY>0 Then 
					ship\y=ship\y-1
					ship\vitesseY=ship\vitesseY+Abs(ship\vitesseRot)/coef
				;	ship\vitesseX=ship\vitesseX-ship\vitesseRot/coef
				Else 
					ship\y=ship\y+1
					ship\vitesseY=ship\vitesseY-Abs(ship\vitesseRot)/coef
				;	ship\vitesseX=ship\vitesseX+ship\vitesseRot/coef
				EndIf
				ship\y=ship\y-ship\vitesseY
				ship\vitesseY=-ship\vitesseY
			EndIf
			
			ship\vitesseRot=-ship\vitesseRot/4
			
		Else 
			If Not isPTin(ship\x,ship\y,0,0,land\larg,land\haut) Then ship_degat(ship,Null,1)	
		EndIf

	EndIf
End Function
;----------------------------------------------------------------------
; Teste si il y a une collision avec un autre ship 
;----------------------------------------------------------------------
Function ship_TestColisionShip()
	Local ship1.typeShip
	Local ship2.TypeShip
	ship1 = First TypeShip 
	ship2 = After ship1
	
	;For ship1 = Each TypeShip
		If (ship2<>Null)Then If ImagesCollide(ship1\Image,ship1\x,ship1\y,ship_getImageNum(ship1),Ship2\image,ship2\x,ship2\y,ship_getImageNum(ship2))
		 If ship1\vivent And ship2\vivent Then
			vitesseShip1X%=ship1\vitesseX
			vitesseShip2Y%=ship1\vitesseY
		
			If ship1\gun\TypeG=Invincible Then
				ship_degat(ship2,ship1,100)
			Else	
				ship1\vitesseX=ship2\vitesseX+Cos(ship2\angle)*ship2\accel
				ship1\vitesseY=ship2\vitesseY+Sin(ship2\angle)*ship2\accel
				ship1\x=ship1\x+ship1\vitesseX*2
				ship1\y=ship1\y+ship1\vitesseY*2
				ship1\vitesseRot=-ship1\vitesseRot
				ship_degat(ship1,ship2,1)
			EndIf
			
			If ship2\gun\TypeG=Invincible Then
				ship_degat(ship1,ship2,100)
			Else
				ship2\vitesseX=vitesseShip1X+Cos(ship1\angle)*ship1\accel
				ship2\vitesseY=vitesseShip1Y+Sin(ship1\angle)*ship1\accel
				ship2\x=ship2\x+ship2\vitesseX*2
				ship2\y=ship2\y+ship2\vitesseY*2
				ship2\vitesseRot=-ship2\vitesseRot
				ship_degat(ship2,ship1,1)
			
				PlaySound(SonRebondShip)
			EndIf
		 EndIf
		EndIf
	;Next
End Function
;----------------------------------------------------------------------
;Function rotation qui permet de faire tourner le ship
;----------------------------------------------------------------------
Function ship_Tourne(Ship.TypeShip,a#)
	Ship\angle=(Ship\angle+a) Mod 360
	If Ship\angle < 0 Then Ship\angle=Ship\angle+360
End Function
;----------------------------------------------------------------------
Function ship_pouseOn(Ship.TypeShip)
	ship\accel=ship\pousee
	particles=CreateParticle(ship) 
	If Not ChannelPlaying(ship\chnlFire) Then ship\chnlFire=PlaySound(ship\sonFire)
End Function
;----------------------------------------------------------------------
Function ship_PouseOff(Ship.TypeShip)
	StopChannel(ship\chnlFire)
	ship\accel=0
End Function
;----------------------------------------------------------------------
;affiche le vesseau dcal de decalx et decaly
;----------------------------------------------------------------------
Function ship_affiche(Ship.TypeShip,decalX%,decalY%)
	If ship\vivent Then
		DrawImage (ship\image,ship\x-decalX,ship\y-decalY,ship_getImageNum(ship))
		If ship\gun\typeG=invincible Then 
			Color (0,0,Rand(0,150))
			Oval(ship\x-decalX-ship\tailleImg/2,ship\y-decalY-ship\tailleImg/2,ship\tailleImg,ship\tailleImg,False)
		EndIf 
	EndIf 
End Function
;----------------------------------------------------------------------
; effectue les dgats sur le vesseau
;----------------------------------------------------------------------
 Function ship_degat(victime.TypeShip,agresseur.TypeShip,dega%)
	If (victime\vivent) And (Not victime\gun\TypeG=Invincible)
		victime\Vie=victime\Vie-dega/victime\bouclier
		If Floor(victime\vie)<=0 Then
			If agresseur=Null Then
				victime\score=victime\score-1
			Else
				agresseur\score=agresseur\score+1
			EndIf
			ship_explode(victime)
			victime\vivent=False;ship_reInit(victime)		
		EndIf
	EndIf 
End Function
;----------------------------------------------------------------------
Function ship_reInit(Ship.TypeShip)
	ship\vitesseX=0
	ship\vitesseY=0
	ship\vitesseRot=0
	ship\angle=270
	ship\vie=ship\vieMax
	Delete ship\gun
	ship\gun = createGun.typeGun(Base)
	ship\vivent=True
	;cherche une position de dpart hors du dcor
	Repeat	 
		ship\x=Rand(0,land\larg)
		ship\y=Rand(0,land\haut)
	Until (Not land_isThereaColision(ship,ship\x,ship\y))
End Function
;----------------------------------------------------------------------
Function ship_explode(Ship.TypeShip)
	PlaySound(SonExplShip)
	Delete ship\gun
	ship\gun = createGun.typeGun(debri)
	For ship\angle=0 To 324 Step 36
		gun_shoot(ship)
	Next
	ship\angle=0
	land_drawOval(ship\x,ship\y,ship\tailleImg)
End Function
;----------------------------------------------------------------------
Function ship_getImageNum%(ship.typeship)
	Return Floor(ship\angle/ship\pasRot)
End Function
;----------------------------------------------------------------------
Function ship_getImageNumAngle%(ship.typeship,angle#)
	Return Floor(angle/ship\pasRot)
End Function
;----------------------------------------------------------------------
Function ship_delete(ship.typeShip)
	FreeImage ship\image
	FreeImage ship\ImagePower
	FreeSound ship\sonFire 
	FreeSound ship\chnlFire
	If ship\ia<>Null Then Delete ship\ia
	Delete ship\gun
	Delete Ship
End Function