Include "ship.bb"
Include "Bullet.bb"

Global ImgBareVie
Global ImgCoeur

Type typeWindow
	Field ship.TypeShip
	Field land.typeLand
	Field x%,y%
	Field haut%,larg%
	
End Type
;----------------------------------------------------------------------
Function createWindow.typeWindow(ship.TypeShip,land.typeLand,x%,y%,larg%,haut%)
	Local window.typeWindow
	window = New typeWindow
	window\ship = ship 
	window\land =land
	window\x=x
	window\y=y
	window\larg=larg
	window\haut=haut
	Return window
End Function 
;----------------------------------------------------------------------
Function window_Affiche(window.typeWindow)
	;calucl de la zone d'affichage du niveau en fonction de la position du vesseau
	Local xRect%=window\ship\x-(window\larg/2)
	Local yRect%=window\ship\y-(window\haut/2)
	If xRect<0 Then xRect=0
	If yRect<0 Then yRect=0
	If xRect+window\larg>window\land\larg Then xRect=window\land\larg-window\larg
	If yRect+window\haut>window\land\haut Then yRect=window\land\haut-window\haut

	Viewport (window\x,window\y,window\larg,window\haut)
	;affichage de l'image d'ariere plan (star)
	TileImage(window\land\imageBackStar,-xRect*.2,-yRect*.2)
	;affichage de l'image de fond 
	Land_affiche(imgBack,window\x,window\y,xRect,yRect,window\larg,window\haut)
	;affichage du niveau
	Land_affiche(imgLand,window\x,window\y,xRect,yRect,window\larg,window\haut)
	;affichage des bonus
	affiche_Bonus(xRect,yRect,window)	
	;affichage des Particles
	Affiche_particles(xRect,yRect,window)	
	;affichage du vesseau
	Affiche_ships(xRect,yRect,window) 
	;affichage des Particles de fume
	Affiche_particlesFume(xRect,yRect,window)	
	;affichage des bullets
	Affiche_Bullets(xRect,yRect,window)
	;affichage de l'immage de devant
	Land_affiche(imgFront,window\x,window\y,xRect,yRect,window\larg,window\haut)	
	;affichage des infos
	Affiche_infoShip(window)
	;affichage du contour
	Color 100,100,250
	Rect(window\x,window\y,window\larg,window\haut,False)
	
	SetBuffer BackBuffer()
End Function 
;----------------------------------------------------------------------
Function Affiche_infoShip(window.TypeWindow)
	drawText(window\x+window\larg-300,window\y+5,"score:"+window\ship\score)
	
	;affichage de la vie
	drawText(window\x+70,window\y+window\haut-110,Int window\ship\vie +"/"+window\ship\vieMax )
	DrawImage(imgCoeur,window\x+5,window\y+window\haut-100)
	DrawImageRect(ImgBareVie,window\x+70,window\y+window\haut-70,0,0,(Float window\ship\vie/window\ship\vieMax)*200,20)
	Color 200,10,10
	Rect(window\x+70,window\y+window\haut-70,200,20,False)
	;affichage de l'arme
	DrawImage(getImgGun(window\ship),window\x+10,window\y+window\haut-40)
	Drawtext(window\x+80,window\y+window\haut-40,Int window\ship\gun\niveau)
	
End Function
;----------------------------------------------------------------------
Function Affiche_Ships(decalX%,decalY%,window.TypeWindow)
	For ships= Each TypeShip
		If isPtIn(Ships\x,Ships\y,decalX,decalY,window\larg,window\haut) Then
			ship_affiche(Ships,decalx-window\x,decalY-window\y)
		EndIf
	Next 
End Function
;----------------------------------------------------------------------
Function Affiche_Bullets(decalX%,decalY%,window.TypeWindow)
	For bullets= Each typeBullet
		If isPtIn(bullets\x,bullets\y,decalX,decalY,window\larg,window\haut) Then
			Bullet_affiche(bullets,decalx-window\x,decalY-window\y)
		EndIf
	Next 
End Function
;----------------------------------------------------------------------
Function Affiche_Particles(decalX%,decalY%,window.TypeWindow)
	For particles= Each typeParticle
		If isPtIn(particles\x,particles\y,decalX,decalY,window\larg,window\haut) Then
			particle_affiche(particles,decalx-window\x,decalY-window\y)
		EndIf
	Next 
End Function
;----------------------------------------------------------------------
Function Affiche_ParticlesFume(decalX%,decalY%,window.TypeWindow)
	For particlesFume= Each typeParticleFume
		If isPtIn(particlesFume\x,particlesFume\y,decalX,decalY,window\larg,window\haut) Then
			particleFume_affiche(particlesFume,decalx-window\x,decalY-window\y)
		EndIf
	Next 
End Function
;----------------------------------------------------------------------
Function Affiche_Bonus(decalX%,decalY%,window.TypeWindow)
	For Bonuses= Each TypeBonus
		If isPtIn(Bonuses\x,Bonuses\y,decalX,decalY,window\larg,window\haut) Then
			Bonus_affiche(Bonuses,decalx-window\x,decalY-window\y)
		EndIf
	Next 
End Function